#include<bits/stdc++.h>
using namespace std;

const int N = 10000000;

long long L, R, ans;
bool primes[N] = {1, 1}, flag;

bool prime(long long a)
{
    if(a == 1) return true;
    if(a == 2 || a == 3) return false;
    if(a % 2 == 0) return true;
    for(int i = 3; i * i <= a; i ++) if(a % i == 0) return true;
    return false;
}

int main()
{
    for(int i = 2; i < sqrt(N); i ++) /// Evklid
    {
        if(primes[i] == true) continue;
        else for(int j = i * i; j < N; j += i) primes[j] = true;
    }
    cin >> L >> R;
    for(long long a = 2; a * a <= R; a ++)
    {
        if(a > N && prime(a) == true) continue;
        else if(primes[a] == true) continue;
        for(long long y = 2; ; y ++)
        {
            if(y + 1 > N && prime(y + 1) == true) continue;
            else if(primes[y + 1] == true) continue;
            else
            {
                long long tmp = pow(a, y);
                ///cout << a << "^" << y << " = " << tmp << endl;
                if(tmp < L || tmp > R) break;
                else ans ++;
            }
        }
    }
    cout << ans << endl;
}
