#include<iostream>
#include<algorithm>
using namespace std;

long long ans=0;

bool is_prime(long long x)
{
    if(!x%2) return false;

    int i=3;
    while(i*i<=x)
    {
        if(!x%i) return false;
        i=i+2;
    }

    return true;
}

bool is_funny(long long x)
{
    int i=2;
    while(1)
    {
        int br=0;
        while(x%i==0) { x=x/i; br++;}

        if(br)
        {
            if(x!=1) return false;
            if(is_prime(2*br+1)) return true;
            return false;
        }

        i++;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    long long l,r;
    cin >> l >> r;

    int i=2;
    while(i*i<l) i++;

    while(i*i<=r)
    {
        if(is_funny(i)) ans++;
        i++;
    }

    cout << ans << endl;

    return 0;
}
