#include<iostream>
#include<cmath>

using namespace std;

bool is_prime(long long x)
{
    if(x==2) return true;
    for(long long i=2;i<=sqrt(x);i++)
    {
        if(x%i==0) return false;
    }
    return true;
}

bool is_prime2(long long x)
{
    long long br=2;
    for(long long i=2;i<=x/2;i++)
    {
        if(x%i==0) br++;
    }
    if(is_prime(br)==true) return true;
    return false;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    long long l,r,br=0;
    cin>>l>>r;

    for(long long i=2;i<=r;i++)
    {
        if(i*i<l) continue;
        if(i*i>r) break;
        if(is_prime2(i*i)==true) br++;
    }

    cout<<br<<"\n";

    return 0;
}
