#include <iostream>
#include <cmath>
#include <vector>
#define ERATOSTEN 10000
using namespace std;
vector <int> prosti;
int brdel(long long x)
{
    long long squareRoot=sqrt(x);
    int br=0;
    if (squareRoot*squareRoot!=x) squareRoot++;
    else br++;
    for (int i=1; i<squareRoot; i++){
        if (x%i==0) br+=2;
    }
    return br;
}
void eratosten()
{
    int a[ERATOSTEN];
    for (int i=0; i<ERATOSTEN; i++){
        a[i]=0;
    }
    for (int i=2; i<ERATOSTEN; i++){
        if (a[i]==0){
            for (int j=2*i; j<ERATOSTEN; j+=i){
                a[j]=1;
            }
        }
    }
    for (int i=3; i<ERATOSTEN; i++){
        if (a[i]!=0) continue;
        prosti.push_back(i);
    }
}
bool isProst(int x)
{
    int psize=prosti.size();
    for (int i=0; i<psize; i++){
        if (prosti[i]==x) return true;
        if (prosti[i]>x) return false;
    }
    return false;
}
int main()
{
    long long l, r, br=0;
    cin>>l>>r;
    eratosten();
    for (long long i=l; i<=r; i++){
        if (isProst(brdel(i))) br++;
    }
    cout<<br<<endl;

    return 0;
}
