#include<iostream>
#include<algorithm>
using namespace std;

long long br_del=1;

bool is_prime(long long x)
{
    if(x==1) return false;
    if(x==2) return true;
    if(x%2==0) return false;

    int i=3;
    while(i*i<=x)
    {
        if(x%i==0) return false;
        i=i+2;
    }

    return true;
}

bool is_funny(long long x)
{
    int i=2;
    while(i*i<=x)
    {
        int br=0;
        while(x%i==0) { x=x/i; br++;}

        if(br!=0)
        {
            if(x!=1) return false;
            if(is_prime(br+1)) return true;
            return false;
        }

        i++;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    long long l,r;
    cin >> l >> r;

    long long ans=0;
    for(long long i=l; i<=r; i++)
        if(!is_prime(i) && is_funny(i)) ans++;

    cout << ans << endl;

    return 0;
}
